# copy text into clipboard (used for "Copy link to clipboard" in Windows GUI Traybar)
# This code is copied from pyperclip. We're not using pyperclip directly because its installation fails on
# non-Windows systems, due to missing requirements. But we only need the Windows implementation

def copy_windows(text):
    import ctypes
    GMEM_DDESHARE = 0x2000
    CF_UNICODETEXT = 13
    d = ctypes.windll  # cdll expects 4 more bytes in user32.OpenClipboard(0)
    try:  # Python 2
        if not isinstance(text, unicode):
            text = text.decode('mbcs')
    except NameError:
        if not isinstance(text, str):
            text = text.decode('mbcs')

    try:
        d.user32.OpenClipboard(None)  # Works on Python 3
    except ctypes.ArgumentError:
        d.user32.OpenClipboard(0)  # Works on Python 2

    d.user32.EmptyClipboard()
    hCd = d.kernel32.GlobalAlloc(GMEM_DDESHARE, len(text.encode('utf-16-le')) + 2)
    pchData = d.kernel32.GlobalLock(hCd)
    ctypes.cdll.msvcrt.wcscpy(ctypes.c_wchar_p(pchData), text)
    d.kernel32.GlobalUnlock(hCd)
    d.user32.SetClipboardData(CF_UNICODETEXT, hCd)
    d.user32.CloseClipboard()
