from infi.vendata.powertools.gui.webapp import json_response
from infi.vendata.powertools.utils import auth
from infi.credentials_store import Credentials


def isbool(val):
    return val in (True, "true")


class Auth(object):

    @json_response
    def has_credentials(self, serial, **kwargs):
        if auth.CREDENTIALS_STORE.get_existing_credentials(serial):
            return True
        return False

    @json_response
    def set_credentials(self, serial, username, password, remember_me, default, **kwargs):
        credentials = Credentials(username, password)
        if auth.CREDENTIALS_STORE.authenticate(serial, credentials):
            if isbool(default):
                auth.CREDENTIALS_STORE.set_default_credentials(credentials, remember_me=isbool(remember_me))
            else:
                auth.CREDENTIALS_STORE.set_credentials(serial, credentials, remember_me=isbool(remember_me))
            return True
        return False

    @json_response
    def reset_credentials(self, **kwargs):
        auth.CREDENTIALS_STORE.reset_credentials()

    @json_response
    def get_current_username(self, serial, **kwargs):
        credentials = auth.CREDENTIALS_STORE.get_existing_credentials(serial)
        return None if credentials is None else credentials.get_username()
