from ......webapp import json_response
from infi.pyutils.lazy import cached_method, clear_cache
from infi.vendata.powertools.volume_resize import engine

class Resize(object):

    @cached_method
    def load_tasks(self, device_name, size):
        arguments = {"<device-or-mount>": device_name, "<size>": size}
        args = engine.convert_arguments(arguments)
        return engine.load_tasks(args)

    @json_response
    def resize_validation(self, device_name, size, **kwargs):
        arguments = {"<device-or-mount>": device_name, "<size>": size}
        args = engine.convert_arguments(arguments)
        return engine.check_preconditions(args)

    @json_response
    def get_resize_tasks(self, device_name, size, **kwargs):
        clear_cache(self.load_tasks)
        return self.load_tasks(device_name, size).get_description()

    @json_response
    def run_resize_task(self, device_name, size, **kwargs):
        # we assume we're getting the same object from the cache between invocations
        tasks = self.load_tasks(device_name, size)
        try:
            tasks.step()
            return 'ok'
        except Exception:
            raise
