mount_modal = {

    popup: function(event) {
        readiness.with_provisioning_enabled(function() {
            var selElement = $(event.target);
            var actions = selElement.closest('.actions');
            var selInfinibox = selElement.closest('.infinibox.root');
            var system_serial = selInfinibox.data('serial');
            auth.spin_call_with_credentials(system_serial,
                function() {
                    var data = {serial: actions.data('serial')};
                    var ajaxOptions = {type: 'post', dataType: "json", data: data, cache: false, url: sources.operations.is_read_only};
                    view.spinAjax(
                        ajaxOptions,
                        function(data) {
                            mount_modal.popup_show(selElement, actions.data("name"), data.return_value.read_only);
                        }
                    );
                }
            );
        });
    },

    popup_show: function(selElement, volume_name, read_only) {
        $("#mount-modal #vol-name").text(volume_name);
        $("#mount-modal #mount-modal-path").val("");
        $("#mount-modal #mount-modal-read-only").toggle(read_only);
        $("#mount-modal").dialog({
            modal: true,
            width: 540,
            height: 300,
            resizable: false,
            buttons: [
                {
                    text: "OK",
                    click: function(event) {
                        $(this).dialog("close");
                        var path = $("#mount-modal-path").val().trim();
                        if (path === "") {
                            showError("ERROR", "ERROR: Invalid mount point");
                            return;
                        }
                        var data = {path: path};
                        operations.perform_operation(selElement, sources.operations.mount, data);
                    }
                },
                {
                    text: "CANCEL",
                    click: function() {
                        $(this).dialog("close");
                    }
                }
            ]
        });
    }

}