var readiness = {

    prepare_host: function(callback) {
        var list_action_url = readiness.ajaxSource.replace("?", "list?");
        var case_info_url = readiness.ajaxSource.replace("?", "case_info?");
        var perform_action_url = readiness.ajaxSource;
        var done_callback = function() {
            readiness.check_if_ready(function () {
                if (!readiness.msg && callback) {
                    callback();
                }
            });
        }
        actions_modal.show("HOST READINESS",
                           "Host is not ready",
                           true,
                           list_action_url,
                           perform_action_url,
                           null,
                           done_callback,
                           case_info_url);
    },

    check_if_ready: function(callback) {
        var ajaxOptions = {type: "GET", dataType: "json", cache: false, url: readiness.ajaxSource};
        var done_callback = function(json) {
            readiness.msg = '';
            if (json.return_value.host_ready) {
                if (!json.return_value.provisioning_enabled) {
                    readiness.msg = 'Host is not ready to perform volume operations';
                }
            }
            else {
                readiness.msg = 'Host is not ready to work with InfiniBox';
            }
            $('.header .unready_msg').text(readiness.msg);
            $('.header .unready').toggle(!!readiness.msg);
            if (callback) callback();
        };
        view.spinAjax(ajaxOptions, done_callback);
    },

    with_provisioning_enabled: function(callback) {
        // Used before volume operations to ensure that they can run
        if (readiness.msg) {
            var done_callback = function() {
                readiness.prepare_host(callback);
            }
            showError("HOST READINESS", readiness.msg + '.', "Click OK to prepare this host.", done_callback);
        }
        else {
            callback();
        }
    },

    prepare_host_callback: function(e){
        readiness.prepare_host();
    },

    init: function() {
        readiness.ajaxSource = sources.status;
        readiness.check_if_ready();
        $('.header .unready .btn').click(readiness.prepare_host_callback);
    }

}
