resize_modal = {

    popup : function(event) {
        readiness.with_provisioning_enabled(function() {
            var target = $(event.target);
            var actions = target.closest('.actions');
            var selInfinibox = target.closest('.infinibox.root');
            var system_serial = selInfinibox.data('serial');
            auth.spin_call_with_credentials(system_serial,
                function() {
                    $("#resize-modal #vol-name").text(actions.data("name"));
                    $("#resize-modal #current-size").text(create_vol_modal.format_size(actions.data("size")));
                    $("#resize-modal-size-text").val("").regexRestrict(RegExp("[^0-9.]", "g"));
                    mult = create_vol_modal.capacity_multiplier;
                    $("#resize-modal-size-unit").val(actions.data("size") >= mult * mult * mult * mult ? "TB" : "GB");
                    $("#resize-modal").dialog({
                        modal: true,
                        width: 540,
                        height: 300,
                        resizable: false,
                        buttons: [
                            {
                                text: "OK",
                                click: function(event) {
                                    var size = $("#resize-modal-size-text").val().trim();
                                    var units = $("#resize-modal-size-unit").val()
                                    if (!size || isNaN(size)) {
                                        showError("ERROR", "ERROR: Volume size is invalid");
                                        return;
                                    }
                                    size = size + units;
                                    var device_name = actions.data("device");
                                    var data = {device_name: device_name, size: size}
                                    var ajaxOptions = {type: "POST", dataType: "json", data: data,
                                                       cache: false, url: sources.operations.resize_validation};
                                    view.spinAjax(ajaxOptions, function() {
                                        $("#resize-modal").dialog("close");
                                        resize_modal.show_actions(device_name, size, target);
                                    });
                                }
                            },
                            {
                                text: "CANCEL",
                                click: function() {
                                    $(this).dialog("close");
                                }
                            }
                        ]
                    });
                }
            );
        });
    },

    show_actions: function(device_name, size, target) {
        var data = {device_name: device_name, size: size};
        actions_modal.show("RESIZE VOLUME STEPS",
                           "Volume resize failed",
                           true,
                           sources.operations.get_resize_tasks,
                           sources.operations.run_resize_task,
                           data,
                           function() {operations.reload_parent_table(target)},
                           null);
   }

}