# http://fedoraproject.org/wiki/Packaging:ScriptletSnippets
# runs after files of the new package are in place
# the %pre script prepared us for upgrade already
#           install  upgrade  uninstall
#  %post    $1 == 1 $1 == 2 (N/A)

{% include 'header.bash' %}

# start
PREFIX_DIR=%{prefix}

echo "Cleaning up old infinidat odm definitions..."
execute chmod +x $PREFIX_DIR/infinidat_clean_odm
execute $PREFIX_DIR/infinidat_clean_odm
echo "Adding infinidat.odm..."
execute odmadd $PREFIX_DIR/infinidat.odm
echo "Applying the new attributes for the boot processes with bosboot..."
PRIMARY_HDISK=$(lsvg -M rootvg | grep ":" | awk -F: '{print $1} ' | uniq)
echo $PRIMARY_HDISK | execute xargs -n 1 bosboot -ad
echo "Installing message catalog..."
execute gencat /etc/methods/NFINIDAT.cat $PREFIX_DIR/NFINIDAT.msg

#end
exit 0
