import unittest
import mock


class VersionTestCase(unittest.TestCase):
    def test_trivial_post_commit(self):
        from . import utils, get_short_version
        with mock.patch.object(utils.execute, 'execute_assert_success') as execute_assert_success:
            execute_assert_success().get_stdout.return_value = 'v2.1.2-54-g92e4e54'
            self.assertEquals('2.1.2.54', get_short_version())

    def test_minor_post_commit(self):
        from . import utils, get_short_version
        with mock.patch.object(utils.execute, 'execute_assert_success') as execute_assert_success:
            execute_assert_success().get_stdout.return_value = 'v2.2-8-g5119bd6'
            self.assertEquals('2.2.0.8', get_short_version())

    def test_real(self):
        from . import get_short_version
        from os import name
        if name == 'nt':
            raise unittest.SkipTest("this test cannot run on windows as needs a unix shell")
        get_short_version()
