# flake8: noqa

import platform
from mock import patch
from infi import unittest
from .. import ReadinessRunner
from infi.vendata.powertools.settings.cases import windows
from infi.vendata.powertools.settings.cases.linux import redhat
from infi.vendata.powertools.settings.cases.linux import centos
from infi.vendata.powertools.settings.cases.linux import ubuntu
from infi.vendata.powertools.settings.cases.linux import suselinux
from infi.vendata.powertools.settings.cases import sunos
from infi.vendata.powertools.settings.cases import aix
from infi.vendata.powertools.utils import get_distribution

class IterateCasesTestCase(unittest.TestCase):
    def test_iter_cases(self):
        system = platform.system().lower()
        if 'windows' == system:
            case_module = windows
        elif 'sunos' == system:
            case_module = sunos
        elif 'aix' == system:
            case_module = aix
        elif 'darwin' == system:
            raise unittest.SkipTest
        else:
            case_module = eval(get_distribution().distname)

        with patch("infi.vendata.powertools.settings.runner.ReadinessRunner._get_platform_specific_case_module",
                   side_effect=lambda: case_module):
            runner = ReadinessRunner()
            self.assertGreater(len(runner.cases), 0)
