
# pylint: disable-all

def setUp():
    from capacity import GB, TiB
    from infi.vendata.smock import HostMock
    mock = HostMock()
    inventory = mock.get_inventory()
    inventory.add_initiator(), inventory.add_initiator()
    system = inventory.add_infinibox(9999)
    system.pools.create(name="default", physical_capacity=100 * TiB, virtual_capacity=100 * TiB)
    inventory.zone_with_system__best_practices(system)
    inventory.register_host_in_system(system)
    mock.start()
    for i in range(40):
        inventory.provision_a_volume_from_system(system, 123 * GB, name='vol%02d' % (i + 1))
    return mock
